---
title: Release 2021-04-28
menuTitle: 2021-04-28
any: true
description: >-
  Changelog for Release 2021-04-28 (oso 0.12.1, sqlalchemy_oso 0.6.1) containing
  new features, bug fixes, and more.
---

## `oso` 0.12.1

### Core

#### Other bugs & improvements

- Correct data filtering bug causing "Unexpected bound variable in
constraint" errors on some policies using negation.

### Rust

#### `derive(PolarClass)` is now supported on Rust enums

Rust enums can use the `PolarClass` derive macro to register as a Polar
class. Variants of the enum are registered in Polar as constants. For
example, the enum:

```rust
#[derive(Clone, Debug, PartialEq, PolarClass)]
enum Role {
    Admin,
    Member,
}
```

is referenced in Polar as:

```polar
allow(actor, _, resource) if actor.role == Role::Admin;
```

Only unit variants are supported currently. Thanks to
[`@seanchen1991`](https://github.com/seanchen1991) for this contribution!

## `sqlalchemy_oso` 0.6.1

### Other bugs & improvements

- Fixed bug in `authorize_model` leading to data filtering queries to have a filter
  even when one policy result was unconditionally true.
